unit Parts;

interface

uses
    Windows, SysUtils, Classes, Menus, Contnrs, IniFiles, jeuc;

type
    //  g[N؂oNX
    TTokSep = set of Char;
    TTokenizer = class
    private
        FText: String;
        FPos: Integer;
        FLen: Integer;
    public
        //  ŏ̃g[N擾(p)
        function First(const Str: String; const Sep: TTokSep): String;
        //  ̃g[N擾
        function Next(const Sep: TTokSep): String;
    end;

//  EDICT ̃tH[}bg
//  KANJI [KANA] /(general information) gloss/gloss/.../
//  KANA /(general information) gloss/gloss/.../ 

type
    //  f[^
    TEntry = class
    public
        //  {
        J: String;
        //  p
        E: String;
        //  oꃊXg
        Lemma: TStringList;
    public
        //  f[^쐬
        constructor Create(const ALine: String);
        //  fXgN^
        destructor Destroy(); override;
    end;

    //  f[^ێNX
    TEdict = class
    private
        //  f[^ێ
        FEdict: TStringList;
        //  oێ
        FLemma: TStringList;
        //  Gg[Xg
        FEntry: TObjectList;
    public
        //  RXgN^
        constructor Create();
        //  fXgN^
        destructor Destroy(); override;
        //  ǂݍ
        procedure LoadFromFile(const APath: String);
        //  f[^NA
        procedure Clear();
        //  f[^XV
        procedure Update();
        //  Ov
        
    end;

type
  TModParts = class(TDataModule)
    MainMenu: TMainMenu;
    MenuHelp: TMenuItem;
    MenuVersion: TMenuItem;
    procedure MenuVersionClick(Sender: TObject);
  private

  public

  end;

var
  ModParts: TModParts;

implementation

uses
    Info;

{$R *.dfm}

var
    SEP_SLASH: Char = '/';
    SEP_BRACKETL: Char = '[';
    SEP_BRACKETR: Char = ']';

//=============================================================================
//  TEntry
//=============================================================================

//-----------------------------------------------------------------------------
constructor TEntry.Create(const ALine: String);
var
    LTokenizer: TTokenizer;
    LToken: String;
begin
    inherited Create();
    Lemma := TStringList.Create();

    //  oƖ𕪊
    try
        LTokenizer := nil;
        try
            LTokenizer := TTokenizer.Create();

            //  1. Ƃ肠{Ɖpɕ

            //  {擾
            J := Trim(LTokenizer.First(ALine, [SEP_SLASH]));
            //  擾
            E := Trim(LTokenizer.Next([]));

            //  2. ł茩o쐬
            LToken := Trim(LTokenizer.First(J, [SEP_BRACKETL]));
            if (LToken <> '') then Lemma.Add(LToken);
            LToken := Trim(LTokenizer.Next([SEP_BRACKETL, SEP_BRACKETR]));
            if (LToken <> '') then Lemma.Add(LToken);
        finally
            LTokenizer.Free();
        end;
    except
    end;
end;

//-----------------------------------------------------------------------------
destructor TEntry.Destroy();
begin
    Lemma.Free();
    inherited;
end;

//=============================================================================
//  TEdict
//=============================================================================

//-----------------------------------------------------------------------------
constructor TEdict.Create();
begin
    FEdict := TStringList.Create();

    FEntry := TObjectList.Create(True);

    FLemma := THashedStringList.Create();
    FLemma.Sorted := True;
end;

//-----------------------------------------------------------------------------
destructor TEdict.Destroy();
begin
    FEntry.Free();
    FEdict.Free();
    FLemma.Free();
end;

//-----------------------------------------------------------------------------
procedure TEdict.LoadFromFile(const APath: String);
begin
    if (FileExists(APath)) then
    begin
        FEdict.LoadFromFile(APath);
        Update();
    end;
end;

//-----------------------------------------------------------------------------
procedure TEdict.Clear();
begin
    FEdict.Clear();
    FEntry.Clear();
    FLemma.Clear();
end;

//-----------------------------------------------------------------------------
procedure TEdict.Update();
var
    i: Integer;
    j: Integer;
    LEntry: TEntry;
begin
    for i := 0 to FEdict.Count - 1 do
    begin
        //  f[^쐬
        //LEntry := TEntry.Create(FEdict[i]);
        LEntry := TEntry.Create(EUCtoSJIS_String(FEdict[i]));
        //  oL[ɂăXgɒǉ
        for j := 0 to LEntry.Lemma.Count - 1 do
        begin
            FLemma.AddObject(LEntry.Lemma[j], LEntry);
        end;
        //  ꊇp̃Xgɒǉ
        FEntry.Add(LEntry);
    end;
end;


//=============================================================================
//  TTokenizer
//=============================================================================

//-----------------------------------------------------------------------------
//  yQlznifty:FDELPHI/MES/16/630@StrTok ֐V[Y
function TTokenizer.First(const Str: String; const Sep: TTokSep): String;
begin
    FText := Str;
    FPos := 1;
    FLen := Length(Str);
    Result := Next(Sep);
end;

//-----------------------------------------------------------------------------
function TTokenizer.Next(const Sep: TTokSep): String;
var
    LIndex: Integer;
begin
    Result := '';
    if (FLen >= FPos) then
    begin
        while ((FPos <= FLen) and (FText[FPos] in Sep)) do
        begin
            Inc(FPos);
        end;
        LIndex := FPos;
        while ((FPos <= FLen) and not (FText[FPos] in Sep)) do
        begin
            if IsDBCSLeadByte(Byte(FText[FPos])) then
            begin
                Inc(FPos);
            end;
            Inc(FPos);
        end;
        Result := Copy(FText, LIndex, FPos - LIndex);
    end;
end;

//=============================================================================
//  DataModule
//=============================================================================

//-----------------------------------------------------------------------------
//  o[W
procedure TModParts.MenuVersionClick(Sender: TObject);
begin
    OpenInfoForm();
end;

end.
